from sage.all import *

M = ModularSymbols(23,sign=1)
HOME = os.environ['HOME']

def out(n1,n2):
    return '%s/comp/heckepoly/23/data/%s-%s.sobj'%(HOME, n1,n2)

def num_integer(n1,n2):
    v = load(out(n1,n2))
    return len([a for a in v if
                a.matrix_from_rows_and_columns([1,2],[1,2]).is_scalar()])

def go():
    w = []
    c = 0
    for n in [0..999]:
        n1 = 10^3*n
        n2 = 10^3*(n+1)
        try:
            c += num_integer(n1,n2)
            w.append((n2,c))
        except:
            return w
    return w

def logdata():
    v = go()
    return [(x, n(log(prime_pi(x))/log(y)) ) for x,y in v]


def hundred_thousand_multiples(v):
    w = [v[n*100 + 99] for n in [0..9]]
    return w


def reducible_primes_range(n1,n2):
    v = load(out(n1,n2))
    P = prime_range(n1, n2)
    return [P[i] for i in range(len(v)) if
            v[i].matrix_from_rows_and_columns([1,2],[1,2]).is_scalar()]

def reducible_primes(k=999):
    if k == 999 and os.path.exists('23-primes.sobj'):
        return load('23-primes.sobj')
    c = []
    for n in [0..k]:
        n1 = 10^3*n
        n2 = 10^3*(n+1)
        c += reducible_primes_range(n1,n2)
        print n
    if k == 999:
        save(c, '23-primes.sobj')
    return c

def step_plot():
    v = reducible_primes()
    w = [(0,0)]
    n = 0
    for p in v:
        w.append((p, n))
        n += 1
        w.append((p, n))        
    return w
