from sage.all import *

M = ModularSymbols(67,sign=1)[2]
assert M.rational_period_mapping()(M.ambient()([0,oo])) == 0

HOME = os.environ['HOME']

def out(n1,n2):
    return '%s/comp/heckepoly/67/data/%s-%s.sobj'%(HOME, n1,n2)
    
def work(n1,n2):
    if os.path.exists(out(n1,n2)):
         return
    v = [M.hecke_matrix(p) for p in prime_range(n1, n2)]
    save(v, out(n1,n2))


def job(D,n1, n2):
    if not os.path.exists(out(n1,n2)):
        print "submitting job for computation %s -- %s"%(n1,n2)
        return D.eval("cwd = os.getcwd(); os.chdir('/home/was/comp/heckepoly/67/'); from comp2 import *; work(%s,%s); os.chdir(cwd)"%(n1,n2), timeout=0)

def go(D, v):
    w = []  
    for n in v:
        print "checking for %sth job"%n
        n1 = 10^3*n
        n2 = 10^3*(n+1)
        w.append(job(D,n1,n2))
    return w
